package org.btcollider.cnc.comm;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CommServer {
	final Logger log = LoggerFactory.getLogger(CommServer.class);

	private ServerSocket serverSocket;

	public CommServer(int port) {
		log.debug("Starting server on port {}", port);

		try {
			this.serverSocket = new ServerSocket();
		} catch (IOException e) {
			log.error("Couldn't allocate server socket", e);
			
			if(this.serverSocket != null && !this.serverSocket.isClosed()) {
				try {
					serverSocket.close();
				} catch (IOException e1) {
					log.error("Server socket couldn't be closed cleanly", e1);
				}
			}
		}

	}

	public void listen() {
		System.out.println("Start listening...");

		ExecutorService es = Executors.newCachedThreadPool();

		while (true) {
			try {
				Socket socket = serverSocket.accept();
				System.out.println("Got connection from " + socket.getInetAddress());
				System.out.println("Starting ClientWorker");
				es.execute(new ClientWorker(socket));

			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
